# 匿评申诉开启时给分配了匿评的学生发消息
class HomeworkAnonymousAppealStartNotifyJob < ApplicationJob
  queue_as :notify

  def perform(homework_common_id)
    homework = HomeworkCommon.find_by(id: homework_common_id)
    return if homework.blank?
    eva_distribution = StudentWorksEvaluationDistribution.where(student_work_id: homework.student_works.pluck(:id))

    attrs = %i[
      user_id trigger_user_id container_id container_type parent_container_id parent_container_type
      belong_container_id belong_container_type viewed tiding_type created_at updated_at
    ]

    same_attrs = {
        trigger_user_id: homework.user_id, container_id: homework.id, container_type: 'HomeworkCommon',
        parent_container_id: homework.id, parent_container_type: 'AnonymousAppeal',
        belong_container_id: homework.course_id, belong_container_type: 'Course',
        viewed: 0, tiding_type: 'HomeworkCommon'
    }
    Tiding.bulk_insert(*attrs) do |worker|

      eva_distribution.pluck(:user_id).uniq.each do |user_id|
        worker.add same_attrs.merge(user_id: user_id)
      end
    end
  end
end
